- hosts: localhost 
  connection: local
  tasks:

    - name: Clone code from git
      git: 
        repo          : "{{ git.repo }}"
        dest          : tmp/{{ project.name }}/src
        remote        : origin
        version       : "{{ git.branch }}"
        force         : True

    - name: Install npm packages using yarn
      command: yarn install
      args:
        chdir: tmp/{{ project.name }}/src

    - name: Copy .env 
      template:
        src   : templates/.env.production
        dest  : tmp/{{ project.name }}/src
        mode  : 0755

    - name: Build
      shell: "yarn run build"
      args:
        chdir: tmp/{{ project.name }}/src
      
# -----------------------------------------------------------------------------
- hosts: all-goods.front 
  remote_user: root 
  tasks:

    - name: Setup user
      user: 
        name: "{{ user }}" 

    - name: Set authorized key
      authorized_key:
        user  : "{{ user }}"
        state : present
        # TODO: I don't like this solution
        key   : "{{ lookup('file', '/home/andrey/.ssh/id_rsa.pub') }}"

    - name: Install system packages
      apt: 
        name:
          - nginx
          - letsencrypt

    - include_role:
        name: nginx
      vars:
        config_type: front 

# -----------------------------------------------------------------------------
- hosts: all-goods.front 
  remote_user: "{{ user }}"
  tasks:

  - name: copy code to remote host 
    synchronize:
      src       : tmp/{{ project.name }}/src/dist
      dest      : "{{ project.dir }}"
